package com.zipcodewilmington.phonebook;

import org.junit.Assert;
import org.junit.Test;

import java.util.ArrayList;
import java.util.Map;

/**
 * Created by leon on 1/23/18.
 */
public class PhoneBookTest {


    /**
     * Created by leon on 1/23/18.
     */





        @Test
        public void testHasEntry(){
            //Given
            PhoneBook book = new PhoneBook();
            String name = "AA";
            ArrayList<String> numbers = new ArrayList<>();
            numbers.add("211-111-2222");

            book.add(name, numbers);

            //When
            boolean actualOutput = book.hasEntry(name);

            //Then
            Assert.assertTrue(actualOutput);
        }

        @Test
        public void testGetArrayListFor(){
            PhoneBook book = new PhoneBook();
            String name = "AA";
            ArrayList<String> numbers = new ArrayList<>();
            numbers.add("211-111-2222");

            book.add(name, numbers);
            ArrayList<String> expected = numbers;
            Assert.assertEquals(numbers, book.getArrayListFor(name));
        }

        @Test
        public void testAdd(){
            //Given
            PhoneBook book = new PhoneBook();
            String name = "AA";
            ArrayList<String> numbers = new ArrayList<>();
                    numbers.add("211-111-2222");
                    numbers.add("242-435-7863");


            //When
            book.add(name, numbers);

            //Then
            Assert.assertEquals(1, book.size());
        }

        /*@Test
        public void testLookup(){
            PhoneBook book = new PhoneBook();

            String name = "AA";
            ArrayList<String> numbers = new ArrayList<>();
            numbers.add("211-111-2222");

            String expectedOutput = numbers;

            book.add(name, phoneNumber);
            Assert.assertEquals(expectedOutput,book.lookup(name));
        }*/

        @Test
        public void testRemove(){
            PhoneBook book = new PhoneBook();

            String name = "AA";
            ArrayList<String> numbers = new ArrayList<>();
            numbers.add("211-111-2222");
            book.add(name,numbers);
            book.remove(name);
           // boolean expected = false;

            Assert.assertEquals(0,book.size());
        }

        @Test
        public void testReverseLookup(){

            PhoneBook book = new PhoneBook();
            String name = "AA";
            String phoneNumber = "211-111-2222";
            ArrayList<String> numbers = new ArrayList<>();
            numbers.add("211-111-2222");
            String expected = name;
            book.add(name,numbers);
            String actual = book.reverseLookup(phoneNumber);

            Assert.assertEquals(expected, actual);
        }

       @Test
        public void testListNamesAndNumbers(){
            PhoneBook book = new PhoneBook();
            String expected = "\nAA : [211-111-2222]\nBB : [898-135-3522]";
            //book.add("AA", "211-111-2222");
           // book.add("BB","322-333-4858");

           ArrayList<String> numbers1 = new ArrayList<>();
           numbers1.add("211-111-2222");
           book.add("AA", numbers1);

           ArrayList<String> numbers2 = new ArrayList<>();
           numbers2.add("898-135-3522");
           book.add("BB", numbers2);

            String actual = book.listNamesAndNumbers();

            Assert.assertEquals(expected, actual);

        }

}
