package com.zipcodewilmington.phonebook;

//import org.junit.Test;
import org.junit.jupiter.api.Test;

import java.util.*;

/**
 * Created by leon on 1/23/18.
 */
public class PhoneBook {

    List<String> numbers = new ArrayList<String>();
    Map<String, ArrayList<String>> map = new TreeMap<>();


    public void add(String name, ArrayList<String> numbers) {

        map.put(name, numbers);

    }



    public boolean hasEntry(String name) {
        boolean check = map.containsKey(name);
        return check;
    }

    public int size() {
        return map.size();
    }

    public ArrayList<String> getArrayListFor(String name){
        return map.get(name);
    }

   /* public String lookup(String name) {
        ArrayList<String> number = map.get(name);

        return number;
    }*/

    public void remove(String name) {
        if(map.containsKey(name)) {
            map.remove(name);

        }

    }

    public String reverseLookup(String phoneNumber) {
        String name = "";
        Set<String> keys = map.keySet();
        for(String key : keys){
            ArrayList<String> numbers = map.get(key);

            if(numbers.contains(phoneNumber)) {
                 name = key;
            }
        }
        return name;
    }

    public String listNamesAndNumbers() {

        StringBuilder sb = new StringBuilder();

        Set<String> keys = map.keySet();
        for(String key : keys){

            sb.append("\n" + key + " : " +  map.get(key));
        }

        System.out.print(sb);
        return sb.toString();
    }




}
